#include <stdlib.h>
#include <time.h>
#include <math.h>
#include <fstream>

/*********************************************************************************************************
:  ... > gen.exe Y_Range N_Points
					 Y_range  -  ( )  ,    
						N_points -  ,   

   M ( "")

:	Y M N
		 N  (x, y)
***********************************************************************************************************/

#define MAX_PNTs 1002

using namespace std;

int A[MAX_PNTs][MAX_PNTs];									//  -     

ofstream out("input.txt");

int main(int argc, char* argv[])		//   : <randseed> <  > <  >
{
	if(argc < 3)
	{
		out << "Too few parameters. Start as: " << endl;
		out << "gen.exe randseed Y_range N_points " << endl;
		return 1;
	}

	if(argc > 4)
	{
		out << "Too many parameters. Start as:  ";
		out << "gen.exe randseed Y_range N_points " << endl;
		return 1;
	}

	srand(atoi(argv[1]));
	int Y = atoi(argv[2]);										//  
	int N = atoi(argv[3]);										//  
	int M = sqrt( (double)( 4 * Y * Y ) / (double) N );			//   M

	M *= 1.4;													//   1,5 


	out << Y << " " << M << " " << N << endl;

	for(int i = 0; i < Y; i++)
		for(int j = 0; j < Y; j++)
			A[i][j] = 0;

	int x, y;
	for(int i = 0; i < N;)
	{
		x = (((double) rand() / (double) RAND_MAX) * Y + 1 );
		y = (((double) rand() / (double) RAND_MAX) * Y + 1 );
		if(y > Y) y = Y;
		if( y == Y ) y--;
		
		if( A[x][y] == 0 )
		{
			A[x][y] = 1;
			out << x << " " << y << endl;
			i++;
		}
	}

	return 0;
}